diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/internet-stack-helper.cc ns-3.47/src/internet/helper/internet-stack-helper.cc
--- ns-3.46/src/internet/helper/internet-stack-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/helper/internet-stack-helper.cc	2026-02-16 16:08:49.608229900 -0800
@@ -12,6 +12,8 @@
 #include "ipv4-global-routing-helper.h"
 #include "ipv4-list-routing-helper.h"
 #include "ipv4-static-routing-helper.h"
+#include "ipv6-global-routing-helper.h"
+#include "ipv6-list-routing-helper.h"
 #include "ipv6-static-routing-helper.h"
 
 #include "ns3/arp-l3-protocol.h"
@@ -19,8 +21,8 @@
 #include "ns3/callback.h"
 #include "ns3/config.h"
 #include "ns3/global-router-interface.h"
+#include "ns3/global-routing.h"
 #include "ns3/icmpv6-l4-protocol.h"
-#include "ns3/ipv4-global-routing.h"
 #include "ns3/ipv4.h"
 #include "ns3/ipv6-extension-demux.h"
 #include "ns3/ipv6-extension-header.h"
@@ -121,11 +123,15 @@
     Ipv4StaticRoutingHelper staticRouting;
     Ipv4GlobalRoutingHelper globalRouting;
     Ipv4ListRoutingHelper listRouting;
-    Ipv6StaticRoutingHelper staticRoutingv6;
+    Ipv6StaticRoutingHelper staticRouting6;
+    Ipv6GlobalRoutingHelper globalRouting6;
+    Ipv6ListRoutingHelper listRouting6;
     listRouting.Add(staticRouting, 0);
     listRouting.Add(globalRouting, -10);
     SetRoutingHelper(listRouting);
-    SetRoutingHelper(staticRoutingv6);
+    listRouting6.Add(staticRouting6, 0);
+    listRouting6.Add(globalRouting6, -10);
+    SetRoutingHelper(listRouting6);
 }
 
 InternetStackHelper::~InternetStackHelper()
@@ -215,10 +221,10 @@
     for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
-        Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
-        if (router)
+        Ptr<GlobalRouter<Ipv4Manager>> routerv4 = node->GetObject<GlobalRouter<Ipv4Manager>>();
+        if (routerv4)
         {
-            Ptr<Ipv4GlobalRouting> gr = router->GetRoutingProtocol();
+            Ptr<Ipv4GlobalRouting> gr = routerv4->GetRoutingProtocol();
             if (gr)
             {
                 currentStream += gr->AssignStreams(currentStream);
@@ -229,7 +235,12 @@
         {
             Ptr<Ipv6Extension> fe = demux->GetExtension(Ipv6ExtensionFragment::EXT_NUMBER);
             NS_ASSERT(fe); // should always exist in the demux
-            currentStream += fe->AssignStreams(currentStream);
+            currentStream += demux->AssignStreams(currentStream);
+        }
+        Ptr<Ipv6ExtensionRoutingDemux> demuxRouter = node->GetObject<Ipv6ExtensionRoutingDemux>();
+        if (demuxRouter)
+        {
+            currentStream += demuxRouter->AssignStreams(currentStream);
         }
         Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
         if (ipv4)
@@ -250,6 +261,22 @@
             }
         }
     }
+    // The below is intentionally left out of the above loop, to avoid some stream
+    // assignment perturbations on existing programs due to adding IPv6 global routing.
+    // Future extensions of this method should also copy this approach.
+    for (auto i = c.Begin(); i != c.End(); ++i)
+    {
+        Ptr<Node> node = *i;
+        Ptr<GlobalRouter<Ipv6Manager>> routerv6 = node->GetObject<GlobalRouter<Ipv6Manager>>();
+        if (routerv6)
+        {
+            Ptr<GlobalRouting<Ipv6RoutingProtocol>> gr = routerv6->GetRoutingProtocol();
+            if (gr)
+            {
+                currentStream += gr->AssignStreams(currentStream);
+            }
+        }
+    }
     return (currentStream - stream);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/ipv4-global-routing-helper.cc ns-3.47/src/internet/helper/ipv4-global-routing-helper.cc
--- ns-3.46/src/internet/helper/ipv4-global-routing-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/helper/ipv4-global-routing-helper.cc	2026-02-16 16:08:49.609229800 -0800
@@ -7,15 +7,16 @@
  */
 #include "ipv4-global-routing-helper.h"
 
+#include "ns3/global-route-manager.h"
 #include "ns3/global-router-interface.h"
-#include "ns3/ipv4-global-routing.h"
+#include "ns3/global-routing.h"
 #include "ns3/ipv4-list-routing.h"
 #include "ns3/log.h"
 
 namespace ns3
 {
 
-NS_LOG_COMPONENT_DEFINE("GlobalRoutingHelper");
+NS_LOG_COMPONENT_DEFINE("Ipv4GlobalRoutingHelper");
 
 Ipv4GlobalRoutingHelper::Ipv4GlobalRoutingHelper()
 {
@@ -36,11 +37,12 @@
 {
     NS_LOG_LOGIC("Adding GlobalRouter interface to node " << node->GetId());
 
-    Ptr<GlobalRouter> globalRouter = CreateObject<GlobalRouter>();
+    Ptr<GlobalRouter<Ipv4Manager>> globalRouter = CreateObject<GlobalRouter<Ipv4Manager>>();
     node->AggregateObject(globalRouter);
 
     NS_LOG_LOGIC("Adding GlobalRouting Protocol to node " << node->GetId());
-    Ptr<Ipv4GlobalRouting> globalRouting = CreateObject<Ipv4GlobalRouting>();
+    Ptr<GlobalRouting<Ipv4RoutingProtocol>> globalRouting =
+        CreateObject<GlobalRouting<Ipv4RoutingProtocol>>();
     globalRouter->SetRoutingProtocol(globalRouting);
 
     return globalRouting;
@@ -49,16 +51,124 @@
 void
 Ipv4GlobalRoutingHelper::PopulateRoutingTables()
 {
-    GlobalRouteManager::BuildGlobalRoutingDatabase();
-    GlobalRouteManager::InitializeRoutes();
+    Ipv4GlobalRouteManager::BuildGlobalRoutingDatabase();
+    Ipv4GlobalRouteManager::InitializeRoutes();
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRoute(Ptr<Node> sourceNode,
+                                    Ipv4Address dest,
+                                    Ptr<OutputStreamWrapper> stream,
+                                    bool nodeIdLookup,
+                                    Time::Unit unit)
+{
+    GlobalRouteManager<Ipv4Manager>::PrintRoute(sourceNode, dest, stream, nodeIdLookup, unit);
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRoute(Ptr<Node> sourceNode,
+                                    Ipv4Address dest,
+                                    bool nodeIdLookup,
+                                    Time::Unit unit)
+{
+    GlobalRouteManager<Ipv4Manager>::PrintRoute(sourceNode, dest, nodeIdLookup, unit);
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRoute(Ptr<Node> sourceNode,
+                                    Ptr<Node> dest,
+                                    Ptr<OutputStreamWrapper> stream,
+                                    bool nodeIdLookup,
+                                    Time::Unit unit)
+{
+    GlobalRouteManager<Ipv4Manager>::PrintRoute(sourceNode, dest, stream, nodeIdLookup, unit);
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRoute(Ptr<Node> sourceNode,
+                                    Ptr<Node> dest,
+                                    bool nodeIdLookup,
+                                    Time::Unit unit)
+{
+    GlobalRouteManager<Ipv4Manager>::PrintRoute(sourceNode, dest, nodeIdLookup, unit);
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRouteAt(Ptr<Node> sourceNode,
+                                      Ipv4Address dest,
+                                      Time printTime,
+                                      Ptr<OutputStreamWrapper> stream,
+                                      bool nodeIdLookup,
+                                      Time::Unit unit)
+{
+    Simulator::Schedule(
+        printTime,
+        static_cast<void (*)(Ptr<Node>, Ipv4Address, Ptr<OutputStreamWrapper>, bool, Time::Unit)>(
+            &Ipv4GlobalRoutingHelper::PrintRoute),
+        sourceNode,
+        dest,
+        stream,
+        nodeIdLookup,
+        unit);
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRouteAt(Ptr<Node> sourceNode,
+                                      Ipv4Address dest,
+                                      Time printTime,
+                                      bool nodeIdLookup,
+                                      Time::Unit unit)
+{
+    Simulator::Schedule(printTime,
+                        static_cast<void (*)(Ptr<Node>, Ipv4Address, bool, Time::Unit)>(
+                            &Ipv4GlobalRoutingHelper::PrintRoute),
+                        sourceNode,
+                        dest,
+                        nodeIdLookup,
+                        unit);
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRouteAt(Ptr<Node> sourceNode,
+                                      Ptr<Node> dest,
+                                      Time printTime,
+                                      Ptr<OutputStreamWrapper> stream,
+                                      bool nodeIdLookup,
+                                      Time::Unit unit)
+{
+    Simulator::Schedule(
+        printTime,
+        static_cast<void (*)(Ptr<Node>, Ptr<Node>, Ptr<OutputStreamWrapper>, bool, Time::Unit)>(
+            &Ipv4GlobalRoutingHelper::PrintRoute),
+        sourceNode,
+        dest,
+        stream,
+        nodeIdLookup,
+        unit);
+}
+
+void
+Ipv4GlobalRoutingHelper::PrintRouteAt(Ptr<Node> sourceNode,
+                                      Ptr<Node> dest,
+                                      Time printTime,
+                                      bool nodeIdLookup,
+                                      Time::Unit unit)
+{
+    Simulator::Schedule(printTime,
+                        static_cast<void (*)(Ptr<Node>, Ptr<Node>, bool, Time::Unit)>(
+                            &Ipv4GlobalRoutingHelper::PrintRoute),
+                        sourceNode,
+                        dest,
+                        nodeIdLookup,
+                        unit);
 }
 
 void
 Ipv4GlobalRoutingHelper::RecomputeRoutingTables()
 {
-    GlobalRouteManager::DeleteGlobalRoutes();
-    GlobalRouteManager::BuildGlobalRoutingDatabase();
-    GlobalRouteManager::InitializeRoutes();
+    Ipv4GlobalRouteManager::DeleteGlobalRoutes();
+    Ipv4GlobalRouteManager::BuildGlobalRoutingDatabase();
+    Ipv4GlobalRouteManager::InitializeRoutes();
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/ipv4-global-routing-helper.h ns-3.47/src/internet/helper/ipv4-global-routing-helper.h
--- ns-3.46/src/internet/helper/ipv4-global-routing-helper.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/helper/ipv4-global-routing-helper.h	2026-02-16 16:08:49.609229800 -0800
@@ -65,6 +65,128 @@
      *
      */
     static void PopulateRoutingTables();
+
+    /**
+     * @brief prints the routing path for a source and destination to the standard cout output
+     * stream. If the routing path does not exist, it prints that the path does not exist between
+     * the nodes in the ostream. This is a scheduler for the PrintRoute call.
+     *
+     * @param sourceNode the source node
+     * @param dest the IPv4 destination address
+     * @param nodeIdLookup print the node id
+     * @param unit the time unit to be used in the report
+     *
+     * @details This method calls the PrintRoutingPath() method of the
+     * Ipv4GlobalRouting for the source and destination to provide
+     * the routing path at the specified time.
+     * Early return will be triggered if inputs are invalid. for example:
+     * if source or destination nodes do not exist, source or destination nodes lack IPv4 instances,
+     * or source node lacks a global routing instance.
+     * If the destination node has multiple IpAddresses, the routing path will be printed for the
+     * first Ip address of the destination Ipv4 Stack.
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           Ipv4Address dest,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
+    /**
+     * @brief prints the routing path for a source and destination.
+     * @copydetails PrintRoute(Ptr<Node>, Ipv4Address, bool, Time::Unit)
+     * @param stream the output stream object to use
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           Ipv4Address dest,
+                           Ptr<OutputStreamWrapper> stream,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
+    /**
+     * @copybrief PrintRoute(Ptr<Node>, Ipv4Address,  bool,
+     * Time::Unit)
+     * If the routing path does not exist, it prints that the path does not exist between
+     * the nodes in the ostream. This is a scheduler for the PrintRoute call.
+     *
+     * @param sourceNode the source node
+     * @param dest the destination node
+     * @param nodeIdLookup print the node id
+     * @param unit the time unit to be used in the report
+     *
+     * @details This method calls the PrintRoutingPath() method of the
+     * Ipv4GlobalRouting for the source and destination to provide
+     * the routing path at the specified time.
+     * Early return will be triggered if inputs are invalid. for example:
+     * if source or destination nodes do not exist, source or destination nodes lack IPv4 instances,
+     * or source node lacks a global routing instance.
+     * If the destination node has multiple IpAddresses, the routing path will be printed for the
+     * first Ip address of the destination Ipv4 Stack.
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           Ptr<Node> dest,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
+    /**
+     * @copybrief PrintRoute(Ptr<Node>, Ipv4Address, Ptr<OutputStreamWrapper>, bool,
+     * Time::Unit)
+     * @copydetails PrintRoute(Ptr<Node>, Ptr<Node>, bool, Time::Unit)
+     * @param stream the output stream object to use
+     */
+    static void PrintRoute(Ptr<Node> sourceNode,
+                           Ptr<Node> dest,
+                           Ptr<OutputStreamWrapper> stream,
+                           bool nodeIdLookup = true,
+                           Time::Unit unit = Time::S);
+
+    /**
+     * @brief prints the routing path for the source and destination at a particular time to the
+     * standard cout output stream.
+     * @copydetails PrintRoute(Ptr<Node>, Ipv4Address, bool, Time::Unit)
+     * @param printTime the time at which the routing path should be printed.
+     */
+    static void PrintRouteAt(Ptr<Node> sourceNode,
+                             Ipv4Address dest,
+                             Time printTime,
+                             bool nodeIdLookup = true,
+                             Time::Unit unit = Time::S);
+
+    /**
+     * @brief Prints the routing path for the source and destination at a particular time.
+     * @copydetails PrintRoute(Ptr<Node>, Ipv4Address,bool, Time::Unit)
+     * @param printTime the time at which the routing path should be printed.
+     * @param stream the output stream object to use
+     */
+    static void PrintRouteAt(Ptr<Node> sourceNode,
+                             Ipv4Address dest,
+                             Time printTime,
+                             Ptr<OutputStreamWrapper> stream,
+                             bool nodeIdLookup = true,
+                             Time::Unit unit = Time::S);
+
+    /**
+     * @copybrief PrintRouteAt(Ptr<Node>, Ipv4Address, Time, bool, Time::Unit)
+     * @copydetails PrintRoute(Ptr<Node>, Ptr<Node>, bool, Time::Unit)
+     * @param printTime the time at which the routing path should be printed.
+     */
+    static void PrintRouteAt(Ptr<Node> sourceNode,
+                             Ptr<Node> dest,
+                             Time printTime,
+                             bool nodeIdLookup = true,
+                             Time::Unit unit = Time::S);
+
+    /**
+     * @copybrief PrintRouteAt(Ptr<Node>, Ipv4Address, Time, bool, Time::Unit)
+     * @copydetails PrintRoute(Ptr<Node>, Ptr<Node>, bool, Time::Unit)
+     * @param printTime the time at which the routing path should be printed.
+     * @param stream the output stream object to use.
+     */
+    static void PrintRouteAt(Ptr<Node> sourceNode,
+                             Ptr<Node> dest,
+                             Time printTime,
+                             Ptr<OutputStreamWrapper> stream,
+                             bool nodeIdLookup = true,
+                             Time::Unit unit = Time::S);
+
     /**
      * @brief Remove all routes that were previously installed in a prior call
      * to either PopulateRoutingTables() or RecomputeRoutingTables(), and
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/ipv4-interface-container.h ns-3.47/src/internet/helper/ipv4-interface-container.h
--- ns-3.46/src/internet/helper/ipv4-interface-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/helper/ipv4-interface-container.h	2026-02-16 16:08:49.609229800 -0800
@@ -70,12 +70,11 @@
      * for-loop to run through the pairs
      *
      * @code
-     *   Ipv4InterfaceContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
      *       std::pair<Ptr<Ipv4>, uint32_t> pair = *i;
-     *       method (pair.first, pair.second);  // use the pair
-     *     }
+     *       method(pair.first, pair.second); // use the pair
+     *   }
      * @endcode
      *
      * @returns an iterator which refers to the first pair in the container.
@@ -92,12 +91,11 @@
      * for-loop to run through the Nodes
      *
      * @code
-     *   NodeContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
      *       std::pair<Ptr<Ipv4>, uint32_t> pair = *i;
-     *       method (pair.first, pair.second);  // use the pair
-     *     }
+     *       method(pair.first, pair.second); // use the pair
+     *   }
      * @endcode
      *
      * @returns an iterator which indicates an ending condition for a loop.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/ipv6-address-helper.cc ns-3.47/src/internet/helper/ipv6-address-helper.cc
--- ns-3.46/src/internet/helper/ipv6-address-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/helper/ipv6-address-helper.cc	2026-02-16 16:08:49.609229800 -0800
@@ -140,7 +140,7 @@
         addrBuf[i] = netBuf[i] | hostBuf[i];
     }
 
-    Ipv6Address addr = Ipv6Address(addrBuf);
+    auto addr = Ipv6Address(addrBuf);
 
     // Remember: hostBuf[15] is the Least Significant Byte.
     uint16_t sum;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/ipv6-global-routing-helper.cc ns-3.47/src/internet/helper/ipv6-global-routing-helper.cc
--- ns-3.46/src/internet/helper/ipv6-global-routing-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/internet/helper/ipv6-global-routing-helper.cc	2026-02-16 16:08:49.609229800 -0800
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2008 INRIA
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+#include "ipv6-global-routing-helper.h"
+
+#include "ns3/global-router-interface.h"
+#include "ns3/global-routing.h"
+#include "ns3/ipv6-list-routing.h"
+#include "ns3/log.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("Ipv6GlobalRoutingHelper");
+
+Ipv6GlobalRoutingHelper::Ipv6GlobalRoutingHelper()
+{
+}
+
+Ipv6GlobalRoutingHelper::Ipv6GlobalRoutingHelper(const Ipv6GlobalRoutingHelper& o)
+{
+}
+
+Ipv6GlobalRoutingHelper*
+Ipv6GlobalRoutingHelper::Copy() const
+{
+    return new Ipv6GlobalRoutingHelper(*this);
+}
+
+Ptr<Ipv6RoutingProtocol>
+Ipv6GlobalRoutingHelper::Create(Ptr<Node> node) const
+{
+    NS_LOG_LOGIC("Adding GlobalRouter interface to node " << node->GetId());
+
+    Ptr<GlobalRouter<Ipv6Manager>> globalRouter = CreateObject<GlobalRouter<Ipv6Manager>>();
+    node->AggregateObject(globalRouter);
+
+    NS_LOG_LOGIC("Adding GlobalRouting Protocol to node " << node->GetId());
+    Ptr<GlobalRouting<Ipv6RoutingProtocol>> globalRouting =
+        CreateObject<GlobalRouting<Ipv6RoutingProtocol>>();
+    globalRouter->SetRoutingProtocol(globalRouting);
+
+    return globalRouting;
+}
+
+void
+Ipv6GlobalRoutingHelper::PopulateRoutingTables()
+{
+    GlobalRouteManager<Ipv6Manager>::InitializeRouters();
+    GlobalRouteManager<Ipv6Manager>::BuildGlobalRoutingDatabase();
+    GlobalRouteManager<Ipv6Manager>::InitializeRoutes();
+}
+
+void
+Ipv6GlobalRoutingHelper::RecomputeRoutingTables()
+{
+    GlobalRouteManager<Ipv6Manager>::DeleteGlobalRoutes();
+    GlobalRouteManager<Ipv6Manager>::BuildGlobalRoutingDatabase();
+    GlobalRouteManager<Ipv6Manager>::InitializeRoutes();
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/ipv6-global-routing-helper.h ns-3.47/src/internet/helper/ipv6-global-routing-helper.h
--- ns-3.46/src/internet/helper/ipv6-global-routing-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/internet/helper/ipv6-global-routing-helper.h	2026-02-16 16:08:49.609229800 -0800
@@ -0,0 +1,92 @@
+/*
+ * Copyright (c) 2008 INRIA
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+#ifndef IPV6_GLOBAL_ROUTING_HELPER_H
+#define IPV6_GLOBAL_ROUTING_HELPER_H
+
+#include "ipv6-routing-helper.h"
+
+#include "ns3/node-container.h"
+
+namespace ns3
+{
+
+/**
+ * @ingroup ipv4Helpers
+ *
+ * @brief Helper class that adds ns3::Ipv4GlobalRouting objects
+ */
+class Ipv6GlobalRoutingHelper : public Ipv6RoutingHelper
+{
+  public:
+    /**
+     * @brief Construct a GlobalRoutingHelper to make life easier for managing
+     * global routing tasks.
+     */
+    Ipv6GlobalRoutingHelper();
+
+    /**
+     * @brief Construct a GlobalRoutingHelper from another previously initialized
+     * instance (Copy Constructor).
+     * @param o object to be copied
+     */
+    Ipv6GlobalRoutingHelper(const Ipv6GlobalRoutingHelper& o);
+
+    // Delete assignment operator to avoid misuse
+    Ipv6GlobalRoutingHelper& operator=(const Ipv6GlobalRoutingHelper&) = delete;
+
+    /**
+     * @returns pointer to clone of this Ipv4GlobalRoutingHelper
+     *
+     * This method is mainly for internal use by the other helpers;
+     * clients are expected to free the dynamic memory allocated by this method
+     */
+    Ipv6GlobalRoutingHelper* Copy() const override;
+
+    /**
+     * @param node the node on which the routing protocol will run
+     * @returns a newly-created routing protocol
+     *
+     * This method will be called by ns3::InternetStackHelper::Install
+     */
+    Ptr<Ipv6RoutingProtocol> Create(Ptr<Node> node) const override;
+
+    /**
+     * @brief Build a routing database and initialize the routing tables of
+     * the nodes in the simulation.  Makes all nodes in the simulation into
+     * routers.
+     *
+     * All this function does is call the functions
+     * BuildGlobalRoutingDatabase () and  InitializeRoutes ().
+     *
+     */
+    static void PopulateRoutingTables();
+
+    /**
+     * @brief Remove all routes that were previously installed in a prior call
+     * to either PopulateRoutingTables() or RecomputeRoutingTables(), and
+     * add a new set of routes.
+     *
+     * This method does not change the set of nodes
+     * over which GlobalRouting is being used, but it will dynamically update
+     * its representation of the global topology before recomputing routes.
+     * Users must first call PopulateRoutingTables() and then may subsequently
+     * call RecomputeRoutingTables() at any later time in the simulation.
+     *
+     */
+    static void RecomputeRoutingTables();
+
+    /**
+     * @brief initialize all nodes as routers. this method queries all the nodes in the simulation
+     * and enables ipv6 forwarding on all of them.
+     */
+    void InitializeRouters();
+};
+
+} // namespace ns3
+
+#endif /* IPV6_GLOBAL_ROUTING_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/helper/ipv6-interface-container.h ns-3.47/src/internet/helper/ipv6-interface-container.h
--- ns-3.46/src/internet/helper/ipv6-interface-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/helper/ipv6-interface-container.h	2026-02-16 16:08:49.609229800 -0800
@@ -105,12 +105,11 @@
      * for-loop to run through the pairs
      *
      * @code
-     *   Ipv6InterfaceContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
      *       std::pair<Ptr<Ipv6>, uint32_t> pair = *i;
-     *       method (pair.first, pair.second);  // use the pair
-     *     }
+     *       method(pair.first, pair.second); // use the pair
+     *   }
      * @endcode
      *
      * @returns an iterator which refers to the first pair in the container.
@@ -127,12 +126,11 @@
      * for-loop to run through the Nodes
      *
      * @code
-     *   NodeContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
      *       std::pair<Ptr<Ipv6>, uint32_t> pair = *i;
-     *       method (pair.first, pair.second);  // use the pair
-     *     }
+     *       method(pair.first, pair.second); // use the pair
+     *   }
      * @endcode
      *
      * @returns an iterator which indicates an ending condition for a loop.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/arp-header.cc ns-3.47/src/internet/model/arp-header.cc
--- ns-3.46/src/internet/model/arp-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/arp-header.cc	2026-02-16 16:08:49.610230000 -0800
@@ -212,10 +212,14 @@
     }
 
     m_type = static_cast<ArpType_e>(i.ReadNtohU16()); // Read OP
-    ReadFrom(i, m_macSource, hardwareAddressLen);     // Read SHA (size HLN)
-    ReadFrom(i, m_ipv4Source);                        // Read SPA (size PLN == 4)
-    ReadFrom(i, m_macDest, hardwareAddressLen);       // Read THA (size HLN)
-    ReadFrom(i, m_ipv4Dest);                          // Read TPA (size PLN == 4)
+
+    m_macSource.SetType("MacAddress", hardwareAddressLen);
+    m_macDest.SetType("MacAddress", hardwareAddressLen);
+
+    ReadFrom(i, m_macSource, hardwareAddressLen); // Read SHA (size HLN)
+    ReadFrom(i, m_ipv4Source);                    // Read SPA (size PLN == 4)
+    ReadFrom(i, m_macDest, hardwareAddressLen);   // Read THA (size HLN)
+    ReadFrom(i, m_ipv4Dest);                      // Read TPA (size PLN == 4)
     return GetSerializedSize();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/candidate-queue.cc ns-3.47/src/internet/model/candidate-queue.cc
--- ns-3.46/src/internet/model/candidate-queue.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/candidate-queue.cc	2026-02-16 16:08:49.610230000 -0800
@@ -26,15 +26,16 @@
  * @param t the SPFVertex type
  * @returns the reference to the output stream
  */
+template <typename T>
 std::ostream&
-operator<<(std::ostream& os, const SPFVertex::VertexType& t)
+operator<<(std::ostream& os, const typename SPFVertex<T>::VertexType& t)
 {
     switch (t)
     {
-    case SPFVertex::VertexRouter:
+    case SPFVertex<T>::VertexRouter:
         os << "router";
         break;
-    case SPFVertex::VertexNetwork:
+    case SPFVertex<T>::VertexNetwork:
         os << "network";
         break;
     default:
@@ -44,10 +45,11 @@
     return os;
 }
 
+template <typename T>
 std::ostream&
-operator<<(std::ostream& os, const CandidateQueue& q)
+operator<<(std::ostream& os, const CandidateQueue<T>& q)
 {
-    const CandidateQueue::CandidateList_t& list = q.m_candidates;
+    const typename CandidateQueue<T>::CandidateList_t& list = q.m_candidates;
 
     os << "*** CandidateQueue Begin (<id, distance, LSA-type>) ***" << std::endl;
     for (auto iter = list.begin(); iter != list.end(); iter++)
@@ -59,32 +61,36 @@
     return os;
 }
 
-CandidateQueue::CandidateQueue()
+template <typename T>
+CandidateQueue<T>::CandidateQueue()
     : m_candidates()
 {
     NS_LOG_FUNCTION(this);
 }
 
-CandidateQueue::~CandidateQueue()
+template <typename T>
+CandidateQueue<T>::~CandidateQueue()
 {
     NS_LOG_FUNCTION(this);
     Clear();
 }
 
+template <typename T>
 void
-CandidateQueue::Clear()
+CandidateQueue<T>::Clear()
 {
     NS_LOG_FUNCTION(this);
     while (!m_candidates.empty())
     {
-        SPFVertex* p = Pop();
+        SPFVertex<T>* p = Pop();
         delete p;
         p = nullptr;
     }
 }
 
+template <typename T>
 void
-CandidateQueue::Push(SPFVertex* vNew)
+CandidateQueue<T>::Push(SPFVertex<T>* vNew)
 {
     NS_LOG_FUNCTION(this << vNew);
 
@@ -95,8 +101,9 @@
     m_candidates.insert(i, vNew);
 }
 
-SPFVertex*
-CandidateQueue::Pop()
+template <typename T>
+SPFVertex<T>*
+CandidateQueue<T>::Pop()
 {
     NS_LOG_FUNCTION(this);
     if (m_candidates.empty())
@@ -104,13 +111,14 @@
         return nullptr;
     }
 
-    SPFVertex* v = m_candidates.front();
+    SPFVertex<T>* v = m_candidates.front();
     m_candidates.pop_front();
     return v;
 }
 
-SPFVertex*
-CandidateQueue::Top() const
+template <typename T>
+SPFVertex<T>*
+CandidateQueue<T>::Top() const
 {
     NS_LOG_FUNCTION(this);
     if (m_candidates.empty())
@@ -121,29 +129,32 @@
     return m_candidates.front();
 }
 
+template <typename T>
 bool
-CandidateQueue::Empty() const
+CandidateQueue<T>::Empty() const
 {
     NS_LOG_FUNCTION(this);
     return m_candidates.empty();
 }
 
+template <typename T>
 uint32_t
-CandidateQueue::Size() const
+CandidateQueue<T>::Size() const
 {
     NS_LOG_FUNCTION(this);
     return m_candidates.size();
 }
 
-SPFVertex*
-CandidateQueue::Find(const Ipv4Address addr) const
+template <typename T>
+SPFVertex<T>*
+CandidateQueue<T>::Find(const IpAddress addr) const
 {
     NS_LOG_FUNCTION(this);
     auto i = m_candidates.begin();
 
     for (; i != m_candidates.end(); i++)
     {
-        SPFVertex* v = *i;
+        SPFVertex<T>* v = *i;
         if (v->GetVertexId() == addr)
         {
             return v;
@@ -153,8 +164,9 @@
     return nullptr;
 }
 
+template <typename T>
 void
-CandidateQueue::Reorder()
+CandidateQueue<T>::Reorder()
 {
     NS_LOG_FUNCTION(this);
 
@@ -170,8 +182,9 @@
  *
  * This ordering is necessary for implementing ECMP
  */
+template <typename T>
 bool
-CandidateQueue::CompareSPFVertex(const SPFVertex* v1, const SPFVertex* v2)
+CandidateQueue<T>::CompareSPFVertex(const SPFVertex<T>* v1, const SPFVertex<T>* v2)
 {
     NS_LOG_FUNCTION(&v1 << &v2);
 
@@ -182,13 +195,15 @@
     }
     else if (v1->GetDistanceFromRoot() == v2->GetDistanceFromRoot())
     {
-        if (v1->GetVertexType() == SPFVertex::VertexNetwork &&
-            v2->GetVertexType() == SPFVertex::VertexRouter)
+        if (v1->GetVertexType() == SPFVertex<T>::VertexNetwork &&
+            v2->GetVertexType() == SPFVertex<T>::VertexRouter)
         {
             result = true;
         }
     }
     return result;
 }
+template class CandidateQueue<Ipv4Manager>;
+template class CandidateQueue<Ipv6Manager>;
 
 } // namespace ns3
